from __future__ import division

import requests
import pronouncing
import readfile

vocabpath = "dataset/final_dataset/preprocfull30000.txt"

#vocabsize = 14725

vocab = readfile._build_vocab(vocabpath)

baseurl = 'http://api.conceptnet.io/related/c/en/'
edgeurl = 'http://api.conceptnet.io/c/en/'

items = {}

#find related words to whatever it says in scoring.txt
#how many related? as many as possible above agiven score?
#at least like 200-300.

#what happens with multiple lines in scoring.txt?

target_write = open('/home/loller/Desktop/RNN/dataset/relateandrhyme.txt', 'w')

good_rhyme_list = []
not_so_good_rhyme_list = []


target = open('/home/loller/Desktop/RNN/dataset/scoring.txt', 'r')
for line in target:
	objects = line.split(', ')
	basescore = float(objects.pop().strip())
	print(basescore)
	for phrase in objects:
		items[phrase] = basescore
	print(items)	
	for item in objects:
		print(item)
		word = item.replace(' ', '_')
		filterurl = baseurl + word + '?filter=/c/en'
		obj = requests.get(filterurl).json()
		#print(obj['related'])
		listofobj = obj['related']
		for rel in listofobj:
			print(rel)
			relatedone = rel['@id'].replace('/c/en/', '').replace('_', ' ')
			weight = float(rel['weight'])
			if not relatedone in items:
				items[relatedone] = weight*basescore
			elif(items[relatedone] < weight*basescore):
				items[relatedone] = weight*basescore



	print(items)
	for key in items.keys():
		if(items[key] > basescore * 0.5): #0.5 might need alternation
			#print(key)
			filterurl = edgeurl + key.replace(' ', '_')
			obj = requests.get(filterurl).json()
			for entry in obj['edges']:
				if('language' in entry['end'] and 'language' in entry['start']):
					if(entry['end']['language'] == 'en' and entry['start']['language'] == 'en'):
						print(entry['end'])
						print(entry['start'])
						print(entry['weight'])
						weightt = float(entry['weight'])
						print('---------')

						#we are looking at key in items

						if (entry['end']['term'].endswith(key.replace(' ', '_'))):
							newitem = entry['start']['term'].replace('/c/en/', '').replace('_', ' ')
							if(newitem not in items):
								items[newitem] = items[key]*(weightt/12)
						else:
							newitem = entry['end']['term'].replace('/c/en/', '').replace('_', ' ')
							if(newitem not in items):
								items[newitem] = items[key]*(weightt/12)

		
						#how do we use weight? maybe divide by 12


	print(items)
	print(len(items))
	onlyonthese = []


	for phrasee in items:
		splits = phrasee.split(' ')
		if (set(splits).issubset(vocab.keys())):
			onlyonthese.append(phrasee)

	#kanskje ha med at de maa komme etter hverandre?

	#test = [i for i in items if i in vocab.keys()]

	possible_rhymes = []

	print(len(onlyonthese))

	print(len(onlyonthese) / len(items))

	print(onlyonthese)
	for ittem in onlyonthese:
		splitword = ittem.split(' ')
		pronounce = splitword.pop()
		rhymewords = pronouncing.rhymes(pronounce)
		if(len(rhymewords) > 0):
			rhymeandvocab = [i for i in rhymewords if i in vocab.keys()]
			if(len(rhymeandvocab) > 0):
				print(ittem)
				print(rhymeandvocab)



				relatedrhymeandvocab = [i for i in rhymeandvocab if i in items.keys()]
				if (len(relatedrhymeandvocab) > 0):
					print(ittem)
					print(relatedrhymeandvocab)

					#lagre som god rim
					for x in relatedrhymeandvocab:
						good_rhyme_list.append({'rhyme1': ittem, 'rhyme2': x, 'score': items[ittem] + items[x]})


				else:
					#lagre som noksaa god rim
					for x in rhymeandvocab:
						not_so_good_rhyme_list.append({'rhyme1': ittem, 'rhyme2': x, 'score': items[ittem]})

#sort lists

newlist = sorted(good_rhyme_list, key=lambda k: k['score'], reverse = True)
newlist2 = sorted(not_so_good_rhyme_list, key=lambda k: k['score'], reverse = True)

target.close()

for ph in onlyonthese:
	target_write.write(ph + ',' + str(items[ph]) + '\n')

target_write.write('---------- \n')

for pair in newlist:
	target_write.write(pair['rhyme1'] + ',' + pair['rhyme2'] + ',' + str(pair['score']) + '\n')

target_write.write('---------- \n')

for pair in newlist2:
	target_write.write(pair['rhyme1'] + ',' + pair['rhyme2'] + ',' + str(pair['score']) + '\n')


target_write.close()


