from __future__ import division
from __future__ import print_function

import collections
import os
import enchant
import tensorflow as tf
import re
import string
from nltk.tokenize import RegexpTokenizer

tokenizer = RegexpTokenizer(r'\w+')

en_dict = enchant.Dict("en_US")

dataset = []

print("kjorer")
songs_number = 0
target = open('final_dataset/full_dataset.txt', 'r')
flag = 0
newDict = {}
removesong = False
for line in target:
	#need to strip the line checking startswith, but not the one added to dataset.
	#print(newDict)

	if (flag == 0):
		songs_number = songs_number + 1
		newDict = {'songtext' : '', 'songname' : '', 'artist' : '' }
		flag = 1
	elif (flag == 1):
		#vi er i sangtekst
		

		#remove lines with []
		#remove thanks to/submitted by/typed by
		#remove words like: repeat, 2x, chorus, verse

		#I AM REMOVING ( AND ) RIGHT NOW



		if ("[" in line.lower() or "]" in line.lower() or "repeat" in line.lower() or "chorus" in line.lower() or "thanks to" in line.lower() or "submitted by" in line.lower() or "typed by" in line.lower() or "verse" in line.lower() or "written by" in line.lower() or "lyrics by" in line.lower() or "(" in line.lower() or ")" in line.lower()):
			removesong = True
			#print('sup')



		if(line.startswith('++++++++++++++++++++++')):
			flag = 2
		else:
			#if(newDict['songtext'].endswith(" \n ")):
			#	newDict['songtext'] = newDict['songtext'] + line.strip() 
			#else:
			newDict['songtext'] = newDict['songtext'] + line.strip() + " \n "

	elif (flag == 2):

		if(line.startswith('++++++++++++++++++++++')):
			flag = 3
		else:
			newDict['songname'] = line


	elif (flag == 3):

		if(line.startswith('++++++++++++++++++++++')):
			flag = 4#HER MAA DET SKJE NOE.
		else:
			newDict['artist'] = line

	if(line.startswith('--------------------')):
		#vi er ferdig med sangen
		flag = 0

		#maa sjekke engelsk
		#maa sjekke duplikater
		#saa legge til i dataset

		tokens = tokenizer.tokenize(newDict['songtext'])

		#print(tokens)

		eng = 0
		for word in tokens:
			if(en_dict.check(word)):
				eng = eng + 1

		percentage = 0.0

		if(len(tokens) == 0):
			removesong = True
		else:
			percentage = eng/len(tokens)

		if(percentage < 0.92):
			removesong = True

		#print(percentage)

		if any(d['songname'] == newDict['songname'] and d['artist'] == newDict['artist'] for d in dataset):
			removesong = True
			#print('gg')

		if(removesong == False):
			dataset.append(newDict)
			#print('yo')

		#print(dataset)

		removesong = False


def _read_words(filename):
  with tf.gfile.GFile(filename, "r") as f:
    a = re.findall(r"[\w']+", f.read().decode("utf-8").replace("\n", "<eos>").lower())
    #print(a)
    return a


def _build_vocab(filename):
  data = _read_words(filename)

  counter = collections.Counter(data)
  count_pairs = sorted(counter.items(), key=lambda x: (-x[1], x[0]))

  words, _ = list(zip(*count_pairs))
  word_to_id = dict(zip(words, range(len(words))))

  return word_to_id


target.close()
#print(dataset)
print(songs_number)

print("skriver")
testnumb = 0
newTarget = open('final_dataset/preprocfull.txt', 'w')
for entry in dataset:
	for k,v in entry.items():
		if(k == "songtext"):
			newTarget.write(str(v) + " \n ")

	testnumb = testnumb+1

newTarget.close()

print(testnumb)


#sjekk top vocab i preprocess
#lag ny fil
#skriv til dataset hvis i top vocab
path = 'final_dataset/preprocfull.txt'
word_to_id = _build_vocab(path)

#print(word_to_id['eos'])
#print(word_to_id)

for i in range(1,9):
	newTarget = open('final_dataset/preprocfull' + str(i*5000) + '.txt', 'w')
	newTarget1 = open('final_dataset/preprocfull' + str(i*5000) + 'train.txt', 'w')
	newTarget2 = open('final_dataset/preprocfull' + str(i*5000) + 'val.txt', 'w')
	newTarget3 = open('final_dataset/preprocfull' + str(i*5000) + 'test.txt', 'w')
	counter_ds = 0
	testnumb = 0
	for entry in dataset:
		for k,v in entry.items():
			if(k == "songtext"):
				song_fresh = str(v).translate(string.maketrans("",""), string.punctuation)
				song_split = song_fresh.split(' ')
				remove = False
				for item in song_split:
					if item.replace('\n', 'eos').lower() in word_to_id:
						if (word_to_id[item.replace('\n', 'eos').lower()] > i*5000):
							remove = True
				if not remove:
					testnumb = testnumb+1
					newTarget.write(str(v) + " \n ")
					if counter_ds < 8:
						newTarget1.write(str(v) + " \n ")
						counter_ds = counter_ds + 1
					elif counter_ds == 8:
						newTarget2.write(str(v) + " \n ")
						counter_ds = counter_ds + 1
					elif counter_ds == 9:
						newTarget3.write(str(v) + " \n ")
						counter_ds = 0


		

	newTarget.close()
	newTarget1.close()
	newTarget2.close()
	newTarget3.close()
	print(testnumb)
















#testnumb = 0
#newTarget = open('preprocessedA.txt', 'w')
#for entry in dataset:
#	for k,v in entry.items():
#		newTarget.write(str(k) + ": \n" + str(v) + "++++++++++++++++++++++ \n")
#
#	newTarget.write("-------------------- \n")
#	testnumb = testnumb+1
#
#newTarget.close()
#
#print(testnumb)

#dataset: problemer: non-engelsk. typed/submitted by. length. other random shit like \xs\xc.