import re
import requests
import time
from bs4 import BeautifulSoup
from django.utils.encoding import smart_str, smart_unicode
import json


baseurl = 'http://www.mldb.org/'

# id = "az" 
# class_ = "centerplane"
# id = "thelist"
# class_ = "songtext" for songtext and class_ = "centerplane" for artist

linksToVisit = []
linksVisited = []

dataset = []

linksToVisit.append('aza-Z-30.html')
# 510 540 570 720 N 90 P 90 240 R 0 30 300 330 S 150 390 540 660 720 T 150 180 210 240 390 510 570 600 630 U 0 V 0 W 30 60
#start paa 330

while(linksToVisit):
	time.sleep(5)

	artistlinks = []

	goTo = linksToVisit.pop()
	linksVisited.append(goTo)
	print(goTo)

	r = requests.get(baseurl + goTo)
	soup = BeautifulSoup(r.content, 'html.parser')
	adata = soup.find_all(class_ = "centerplane")

	for item in adata:                                    #Gaar gjennom hele siden
		newlinks = item.find_all('a')					  #Finner alle linker som er artister og linker til andre sider.
		noDup = list(set(newlinks))					      #Sletter duplikater 4head

		print(noDup)

		for finda in noDup:
			findart = finda.get('href')
			if (findart.startswith('aza') and findart not in linksVisited and findart not in linksToVisit): #Sjekk om det er til artist eller annen side
				#linksToVisit.append(findart)
				print('yo')

			elif (findart.startswith('artist')):
				if(findart != 'artist-2911-marianne-faithfull.html' and findart != 'artist-46-mariah-carey.html'):
					artistlinks.append(findart)

		noDupArtLinks = list(set(artistlinks))
		print(linksToVisit)
		print(len(linksToVisit))
		print(noDupArtLinks)
		print(len(noDupArtLinks))


		i = 0
		j = 0

		for artlink in noDupArtLinks:
			time.sleep(2)
			print(i)
			i = i+1
			r = requests.get(baseurl + artlink)
			soup = BeautifulSoup(r.content, 'html.parser')
			albums = soup.find_all(id = "thelist")						  #Har alle linkene til album og sanger til en gitt artist
			for link in albums:											  
				songlink = link.find_all('a')							  #Extracter alle linker. Baade album og sanger
				for entry in songlink:
					finallink = entry.get('href')
					#print(finallink)
					if(finallink.startswith('song')):
						time.sleep(1)
						print(j)
						r = requests.get(baseurl + finallink)
						soup = BeautifulSoup(r.content, 'html.parser')
						artist = soup.find_all(class_ = "centerplane")	
						song = soup.find_all(class_ = "songtext")
						#print(artist[0].text.encode('utf-8'))

						#sangnavn er start helt til "lyricsRating:". Artist er fra Artist(s) til Album(s)
						#print(song)	
						#sangtekst er all tekst

						thissongname = artist[0].text.encode('utf-8')[:artist[0].text.encode('utf-8').find("lyricsRating:")]
						if (thissongname.startswith('\n')):
							thissongname = thissongname[1:len(thissongname) - 1]
						thisartist =	artist[0].text.encode('utf-8')[artist[0].text.encode('utf-8').find("Artist(s)") + len('artist(s)'):artist[0].text.encode('utf-8').find("Album(s)")]
						thissongtext = song[0].text

						songdict = {'artist' : thisartist , 'songname' : thissongname, 'songtext' : smart_str(thissongtext)}

						#print(songdict)

						j = j + 1
						dataset.append(songdict)



#hvis slutten  av sangtekst er "submitted by" eller "typed by" saa fjern det. eller [thanks to]
#write dataset to file.
#meaning of \n \t \r \'
#fiks *inhales deeply*
#fiks \x2\xc etc 


#print(dataset)

#s = str(dataset)

#target = open('songs.txt', 'w')
#target.write(s)
#target.close()

target = open('songsM450.txt', 'a')
for entry in dataset:
	for k,v in entry.items():
		target.write(str(k) + ": \n" + str(v) + "\n" + "++++++++++++++++++++++ \n")

	target.write("-------------------- \n")

target.close()


#dataset: problemer: non-engelsk. typed/submitted by. length. other random shit like \xs\xc.


#todo's: remove []. remove non-english text. remove thanks to/submitted by/typed by



#BANNED
#195 3c
#212 52
#43 5e
#36 29
#54 
#71 1a
#53 9e
#72 7f


#start paa180